package com.ruoyi.business.mapper;

import java.util.List;
import com.ruoyi.business.domain.HwDevice;
import com.ruoyi.business.domain.VO.DeviceModeVo;
import com.ruoyi.business.domain.VO.HwMonitorUnitVo;

/**
 * 设备信息Mapper接口
 *
 * @author xins
 * @date 2023-08-24
 */
public interface HwDeviceMapper
{
    /**
     * 查询设备信息
     *
     * @param deviceId 设备信息主键
     * @return 设备信息
     */
    public HwDevice selectHwDeviceByDeviceId(Long deviceId);
    List<HwDevice> selectDeviceByMonitorId(Long monitorUnitId);
    Integer selectSumDeviceFlagNot0();

    /**
     * 查询3.	设备各类型占所有设备数量百分比饼状图（左下角）
     * */
    public List<DeviceModeVo> selectDeviceModeNameVo();
    /**
     * 查询设备信息列表
     *
     * @param hwDevice 设备信息
     * @return 设备信息集合
     */
    public List<HwDevice> selectHwDeviceList(HwDevice hwDevice);

    public List<HwDevice> selectDeviceByDeviceModeBySceneId(Long sceneId);
    public List<HwDevice> selectDeviceByDeviceModeByMonitorUnitId(Long monitor_unit_id);
    String selectDeviceByDeviceModeByDeviceModeFunction(Long deviceId);
    String selectDeviceModeFunctionByFunctionType(Long deviceId);
    List<HwDevice> selectDeviceNum(Long sceneId);

    /**
     * 新增设备信息
     *
     * @param hwDevice 设备信息
     * @return 结果
     */
    public int insertHwDevice(HwDevice hwDevice);

    /**
     * 修改设备信息
     *
     * @param hwDevice 设备信息
     * @return 结果
     */
    public int updateHwDevice(HwDevice hwDevice);

    /**
     * 删除设备信息
     *
     * @param deviceId 设备信息主键
     * @return 结果
     */
    public int deleteHwDeviceByDeviceId(Long deviceId);

    /**
     * 批量删除设备信息
     *
     * @param deviceIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteHwDeviceByDeviceIds(Long[] deviceIds);


    public int getOnlineDeviceNum(Long sceneId);

    public HwDevice selectHwDeviceJoinByDeviceId(Long deviceId);

    public List<HwDevice> selectLinkedDevices(Long deviceId);


    /**
     * 查询设备信息列表,join监控单元、设备模型等表
     *
     * @param hwDevice 设备信息
     * @return 设备信息集合
     */
    public List<HwDevice> selectHwDeviceJoinList(HwDevice hwDevice);
}
